//---------------------------------------------------------------------------
//
// Name:        ProgramaDlg.cpp
// Author:      A-E
// Created:     2008-08-20 22:29:12
// Description: ProgramaDlg class implementation
//
//---------------------------------------------------------------------------

#include <fstream>
using namespace std;
#include "ProgramaDlg.h"
#include "Forma_pag.h"

//Do not add custom headers
//wxDev-C++ designer will remove them
////Header Include Start
////Header Include End

//----------------------------------------------------------------------------
// ProgramaDlg
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(ProgramaDlg,wxDialog)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(ProgramaDlg::OnClose)
	EVT_ACTIVATE(ProgramaDlg::ProgramaDlgActivate)
	EVT_BUTTON(ID_SP_PAGALBA,ProgramaDlg::sp_pagalbaClick)
	EVT_BUTTON(ID_SP_ISSAUG,ProgramaDlg::sp_issaugClick)
	EVT_BUTTON(ID_SP_DARYTI,ProgramaDlg::sp_darytiClick)
	EVT_RADIOBUTTON(ID_RADIO_WIRE,ProgramaDlg::radio_wireClick)
	EVT_RADIOBUTTON(ID_RADIO_TEK,ProgramaDlg::radio_tekClick)
	EVT_BUTTON(ID_WXBUTTON2,ProgramaDlg::WxButton2Click)
	EVT_BUTTON(ID_WXBUTTON1,ProgramaDlg::WxButton1Click)
END_EVENT_TABLE()
////Event Table End

ProgramaDlg::ProgramaDlg(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxDialog(parent, id, title, position, size, style)
{
	CreateGUIControls();
	t_obj->SetFocus();
}

ProgramaDlg::~ProgramaDlg()
{
} 

void ProgramaDlg::CreateGUIControls()
{
	//Do not add custom code between
	//GUI Items Creation Start and GUI Items Creation End.
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	SetTitle(wxT("3D swf"));
	SetIcon(wxNullIcon);
	SetSize(8,8,324,277);
	Center();
	

	check_html = new wxCheckBox(this, ID_WXCHECKBOX1, wxT("HTML"), wxPoint(6,220), wxSize(48,17), 0, wxDefaultValidator, wxT("check_html"));
	check_html->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	check_smooth = new wxCheckBox(this, ID_WXCHECKBOX1, wxT("Smooth"), wxPoint(252,79), wxSize(97,17), 0, wxDefaultValidator, wxT("check_smooth"));
	check_smooth->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	check_double = new wxCheckBox(this, ID_WXCHECKBOX1, wxT("2-sided"), wxPoint(252,57), wxSize(97,17), 0, wxDefaultValidator, wxT("check_double"));
	check_double->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	atidaryti2 =  new wxFileDialog(this, wxT("Tekstura"), wxT(""), wxT(""), wxT("24-bit TGA failai (*.tga)|*.tga"), wxOPEN | wxFILE_MUST_EXIST);

	atidaryti =  new wxFileDialog(this, wxT("3D failas"), wxT(""), wxT(""), wxT("3D failas (*.3DO)|*.3DO|ASE failas (*.ASE)|*.ASE"), wxOPEN | wxFILE_MUST_EXIST);

	issaugoti =  new wxFileDialog(this, wxT("Issaugoti"), wxT(""), wxT("3D"), wxT("*.swf"), wxSAVE);

	WxStaticText16 = new wxStaticText(this, ID_WXSTATICTEXT16, wxT("Fono spalva:"), wxPoint(16,80), wxDefaultSize, 0, wxT("WxStaticText16"));
	WxStaticText16->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	edit_fb = new wxTextCtrl(this, ID_EDIT_FB, wxT("0"), wxPoint(191,78), wxSize(32,19), 0, wxDefaultValidator, wxT("edit_fb"));
	edit_fb->SetMaxLength(3);
	edit_fb->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxStaticText15 = new wxStaticText(this, ID_WXSTATICTEXT15, wxT("B"), wxPoint(182,81), wxDefaultSize, 0, wxT("WxStaticText15"));
	WxStaticText15->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	edit_fg = new wxTextCtrl(this, ID_EDIT_FG, wxT("0"), wxPoint(144,78), wxSize(32,19), 0, wxDefaultValidator, wxT("edit_fg"));
	edit_fg->SetMaxLength(3);
	edit_fg->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxStaticText14 = new wxStaticText(this, ID_WXSTATICTEXT14, wxT("G"), wxPoint(133,80), wxDefaultSize, 0, wxT("WxStaticText14"));
	WxStaticText14->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	edit_fr = new wxTextCtrl(this, ID_EDIT_FR, wxT("0"), wxPoint(96,78), wxSize(32,19), 0, wxDefaultValidator, wxT("edit_fr"));
	edit_fr->SetMaxLength(3);
	edit_fr->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxStaticText13 = new wxStaticText(this, ID_WXSTATICTEXT13, wxT("R"), wxPoint(87,80), wxDefaultSize, 0, wxT("WxStaticText13"));
	WxStaticText13->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	sp_pagalba = new wxButton(this, ID_SP_PAGALBA, wxT("?"), wxPoint(290,218), wxSize(21,21), 0, wxDefaultValidator, wxT("sp_pagalba"));
	sp_pagalba->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	edit_b = new wxTextCtrl(this, ID_EDIT_B, wxT("0"), wxPoint(191,55), wxSize(32,19), 0, wxDefaultValidator, wxT("edit_b"));
	edit_b->SetMaxLength(3);
	edit_b->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxStaticText12 = new wxStaticText(this, ID_WXSTATICTEXT12, wxT("B"), wxPoint(182,58), wxDefaultSize, 0, wxT("WxStaticText12"));
	WxStaticText12->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	edit_g = new wxTextCtrl(this, ID_EDIT_G, wxT("255"), wxPoint(144,55), wxSize(32,19), 0, wxDefaultValidator, wxT("edit_g"));
	edit_g->SetMaxLength(3);
	edit_g->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxStaticText9 = new wxStaticText(this, ID_WXSTATICTEXT9, wxT("G"), wxPoint(133,57), wxDefaultSize, 0, wxT("WxStaticText9"));
	WxStaticText9->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	edit_r = new wxTextCtrl(this, ID_EDIT_R, wxT("0"), wxPoint(96,55), wxSize(32,19), 0, wxDefaultValidator, wxT("edit_r"));
	edit_r->SetMaxLength(3);
	edit_r->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxStaticText2 = new wxStaticText(this, ID_WXSTATICTEXT2, wxT("Objektas:"), wxPoint(4,8), wxDefaultSize, 0, wxT("WxStaticText2"));
	WxStaticText2->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	edit_pas_y = new wxTextCtrl(this, ID_EDIT_PAS_Y, wxT("0.0"), wxPoint(220,167), wxSize(32,19), 0, wxDefaultValidator, wxT("edit_pas_y"));
	edit_pas_y->SetMaxLength(7);
	edit_pas_y->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	edit_poz_y = new wxTextCtrl(this, ID_EDIT_POZ_Y, wxT("0,0"), wxPoint(350,-256), wxSize(32,19), 0, wxDefaultValidator, wxT("edit_poz_y"));
	edit_poz_y->SetToolTip(wxT("FPS"));
	edit_poz_y->SetMaxLength(7);
	edit_poz_y->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	tekstas = new wxStaticText(this, ID_TEKSTAS, wxT("Zoom:"), wxPoint(245,137), wxDefaultSize, 0, wxT("tekstas"));
	tekstas->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	edit_kam_zoom = new wxTextCtrl(this, ID_EDIT_POZ_X, wxT("1.0"), wxPoint(278,136), wxSize(32,19), 0, wxDefaultValidator, wxT("edit_kam_zoom"));
	edit_kam_zoom->SetMaxLength(7);
	edit_kam_zoom->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxStaticText8 = new wxStaticText(this, ID_WXSTATICTEXT8, wxT("Z:"), wxPoint(257,169), wxDefaultSize, 0, wxT("WxStaticText8"));
	WxStaticText8->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	edit_pas_z = new wxTextCtrl(this, ID_EDIT_PAS_Z, wxT("0.0"), wxPoint(270,167), wxSize(32,19), 0, wxDefaultValidator, wxT("edit_pas_z"));
	edit_pas_z->SetMaxLength(7);
	edit_pas_z->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxStaticText7 = new wxStaticText(this, ID_WXSTATICTEXT7, wxT("Y:"), wxPoint(209,169), wxDefaultSize, 0, wxT("WxStaticText7"));
	WxStaticText7->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxEdit3 = new wxTextCtrl(this, ID_WXEDIT3, wxT("0,0"), wxPoint(319,-415), wxSize(32,19), 0, wxDefaultValidator, wxT("WxEdit3"));
	WxEdit3->SetToolTip(wxT("FPS"));
	WxEdit3->SetMaxLength(7);
	WxEdit3->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxStaticText6 = new wxStaticText(this, ID_WXSTATICTEXT6, wxT("X:"), wxPoint(162,169), wxDefaultSize, 0, wxT("WxStaticText6"));
	WxStaticText6->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxStaticText5 = new wxStaticText(this, ID_WXSTATICTEXT5, wxT("Objekto pasisukimas per kadra:"), wxPoint(6,169), wxDefaultSize, 0, wxT("WxStaticText5"));
	WxStaticText5->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	edit_pas_x = new wxTextCtrl(this, ID_EDIT_PAS_X, wxT("0.0"), wxPoint(173,167), wxSize(32,19), 0, wxDefaultValidator, wxT("edit_pas_x"));
	edit_pas_x->SetMaxLength(7);
	edit_pas_x->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxStaticText4 = new wxStaticText(this, ID_WXSTATICTEXT4, wxT("Kameros Z koordinate:"), wxPoint(82,138), wxDefaultSize, 0, wxT("WxStaticText4"));
	WxStaticText4->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	edit_kam_z = new wxTextCtrl(this, ID_EDIT_KAM_Z, wxT("100.0"), wxPoint(194,136), wxSize(44,19), 0, wxDefaultValidator, wxT("edit_kam_z"));
	edit_kam_z->SetMaxLength(7);
	edit_kam_z->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxStaticText3 = new wxStaticText(this, ID_WXSTATICTEXT3, wxT("FPS:"), wxPoint(9,138), wxDefaultSize, 0, wxT("WxStaticText3"));
	WxStaticText3->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	edit_fps = new wxTextCtrl(this, ID_EDIT_FPS, wxT("24"), wxPoint(35,136), wxSize(40,19), 0, wxDefaultValidator, wxT("edit_fps"));
	edit_fps->SetToolTip(wxT("FPS"));
	edit_fps->SetMaxLength(7);
	edit_fps->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	check_pele = new wxCheckBox(this, ID_CHECK_PELE, wxT("Valdymas pele"), wxPoint(173,108), wxSize(121,17), 0, wxDefaultValidator, wxT("check_pele"));
	check_pele->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	check_rod = new wxCheckBox(this, ID_CHECK_ROD, wxT("Valdymas (rodykles)"), wxPoint(15,108), wxSize(121,17), 0, wxDefaultValidator, wxT("check_rod"));
	check_rod->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	sp_issaug = new wxButton(this, ID_SP_ISSAUG, wxT("..."), wxPoint(287,191), wxSize(25,22), 0, wxDefaultValidator, wxT("sp_issaug"));
	sp_issaug->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	t_issaug = new wxTextCtrl(this, ID_T_ISSAUG, wxT(""), wxPoint(54,193), wxSize(231,19), 0, wxDefaultValidator, wxT("t_issaug"));
	t_issaug->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxStaticText0 = new wxStaticText(this, ID_WXSTATICTEXT0, wxT("Issaugoti:"), wxPoint(5,194), wxDefaultSize, 0, wxT("WxStaticText0"));
	WxStaticText0->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	sp_daryti = new wxButton(this, ID_SP_DARYTI, wxT("GO"), wxPoint(59,218), wxSize(229,21), 0, wxDefaultValidator, wxT("sp_daryti"));
	sp_daryti->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	radio_wire = new wxRadioButton(this, ID_RADIO_WIRE, wxT("Wireframe"), wxPoint(14,55), wxSize(70,17), 0, wxDefaultValidator, wxT("radio_wire"));
	radio_wire->SetValue(true);
	radio_wire->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	radio_tek = new wxRadioButton(this, ID_RADIO_TEK, wxT("Tekstura"), wxPoint(14,32), wxSize(64,17), 0, wxDefaultValidator, wxT("radio_tek"));
	radio_tek->SetForegroundColour(wxColour(*wxWHITE));
	radio_tek->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxButton2 = new wxButton(this, ID_WXBUTTON2, wxT("..."), wxPoint(286,29), wxSize(25,22), 0, wxDefaultValidator, wxT("WxButton2"));
	WxButton2->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	t_tek = new wxTextCtrl(this, ID_T_TEK, wxT(""), wxPoint(80,31), wxSize(204,19), 0, wxDefaultValidator, wxT("t_tek"));
	t_tek->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxStaticText1 = new wxStaticText(this, ID_WXSTATICTEXT1, wxT("R"), wxPoint(87,57), wxDefaultSize, 0, wxT("WxStaticText1"));
	WxStaticText1->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	t_obj = new wxTextCtrl(this, ID_T_OBJ, wxT(""), wxPoint(53,7), wxSize(231,19), 0, wxDefaultValidator, wxT("t_obj"));
	t_obj->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxButton1 = new wxButton(this, ID_WXBUTTON1, wxT("..."), wxPoint(286,5), wxSize(25,22), 0, wxDefaultValidator, wxT("WxButton1"));
	WxButton1->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	////GUI Items Creation End
	
	t_tek->SetEditable(false);
	lang_pagalba = NULL;
}


/*
 * ProgramaDlgActivate
 */
void ProgramaDlg::ProgramaDlgActivate(wxActivateEvent& event)
{
}

void ProgramaDlg::OnClose(wxCloseEvent& /*event*/)
{
	Destroy();
}

/*
 * WxButton1Click
 */
void ProgramaDlg::WxButton1Click(wxCommandEvent& event)
{
	atidaryti->ShowModal();
	t_obj->SetValue(atidaryti->GetPath());
}

/*
 * WxButton2Click
 */
void ProgramaDlg::WxButton2Click(wxCommandEvent& event)
{
	atidaryti2->ShowModal();
	t_tek->SetValue(atidaryti2->GetPath());
}

/*
 * sp_issaugClick
 */
void ProgramaDlg::sp_issaugClick(wxCommandEvent& event)
{
	issaugoti->ShowModal();
	t_issaug->SetValue(issaugoti->GetPath());
}

/*
 * sp_darytiClick
 */
void ProgramaDlg::sp_darytiClick(wxCommandEvent& event)
{
	/*
		unsigned int
			h_tek_x,
			h_tek_y;
		bool
			h_rod,
			h_pele,
			h_double,
			h_smooth;
		unsigned int
			h_wire
			h_fonas;
		float
			h_fps,
			h_kam_z,
			h_kam_zoom,
			,
			h_pas_x,
			h_pas_y,
			h_pas_z;
		unsigned int
			h_obj,
			h_tek;
		unsigned char
			*obj,
			*tek;
	*/
	
	//Gauti nustatymus
	double double_float;
	long longas;
	wxString str;
	
	wxStandardPaths paths;
	str = paths.GetExecutablePath();
	pav_swf = new char[str.Length() + 1];
	strcpy((char*)pav_swf, str.ToAscii());
	
	h_tek = radio_tek->GetValue();
	h_wire_b = radio_wire->GetValue();
	h_rod = check_rod->GetValue();
	h_pele = check_pele->GetValue();
	h_double = check_double->GetValue();
	h_smooth = check_smooth->GetValue();
	
	str = t_obj->GetValue();
	if(str.Length() > 0){
		pav_obj = new char[str.Length() + 1];
		strcpy((char*)pav_obj, str.ToAscii());
	}
	else{
		Zinute("Nenurodytas 3D failas");
		return;
	}
	str = t_tek->GetValue();
	if(str.Length() > 0){
		pav_tek = new char[str.Length() + 1];
		strcpy((char*)pav_tek, str.ToAscii());
	}
	else{
		if(h_tek){
			Zinute("Nenurodyta tekstura, bus naudojamas Wireframe", "Ispejimas");
			h_tek = false;
		}
	}
	str = t_issaug->GetValue();
	if(str.Length() > 0){
		pav_issaug = new char[str.Length() + 1];
		strcpy((char*)pav_issaug, str.ToAscii());
	}
	else{
		Zinute("Nenurodytas swf failas");
		return;
	}
	
	if(edit_fps->GetValue().ToDouble(&double_float))
		h_fps = double_float;
	if(edit_kam_z->GetValue().ToDouble(&double_float))
		h_kam_z = double_float;
	if(edit_kam_zoom->GetValue().ToDouble(&double_float))
		h_kam_zoom = double_float;
	
	if(edit_pas_x->GetValue().ToDouble(&double_float))
		h_pas_x = double_float;
	if(edit_pas_y->GetValue().ToDouble(&double_float))
		h_pas_y = double_float;
	if(edit_pas_z->GetValue().ToDouble(&double_float))
		h_pas_z = double_float;
	
	/*if(edit_poz_x->GetValue().ToLong(&longas))
		h_poz_x = longas;
	if(edit_poz_y2->GetValue().ToLong(&longas))
		h_poz_y = longas;*/
	
	if(edit_fr->GetValue().ToLong(&longas))
		h_r = longas;
	if(edit_fg->GetValue().ToLong(&longas))
		h_g = longas;
	if(edit_fb->GetValue().ToLong(&longas))
		h_b = longas;
	h_fonas = (((h_r << 8) + h_g) << 8) + h_b;
	
	if(edit_r->GetValue().ToLong(&longas))
		h_r = longas;
	if(edit_g->GetValue().ToLong(&longas))
		h_g = longas;
	if(edit_b->GetValue().ToLong(&longas))
		h_b = longas;
	h_wire = (((h_r << 8) + h_g) << 8) + h_b;
	
	/*str = "";
	str<<"SWF: "<<h_kam_z;
	tekstas->SetLabel(str);*/
	
	//Skaityti duomenis
	FILE *ff = fopen(pav_swf, "rb");
	fseek(ff, 0, SEEK_END);
	fseek(ff, -4, SEEK_END);
	fread(&swf_dydis, 4, 1, ff);
	fseek(ff, -(swf_dydis + 4), SEEK_END);
	swf = new char[swf_dydis];
	fread(swf, 1, swf_dydis, ff);
    fclose(ff);
    
    if(strcmp((pav_obj + strlen(pav_obj) - 3), "3DO") == 0){
		ff = fopen(pav_obj, "rb");
		fseek(ff, 0, SEEK_END);
		obj_dydis = ftell(ff);
		fseek(ff, 0, SEEK_SET);
		obj = new char[obj_dydis];
		fread(obj, 1, obj_dydis, ff);
		fclose(ff);
	}
	if(strcmp((pav_obj + strlen(pav_obj) - 3), "ASE") == 0){
		F_3DO failas;
		failas.Uzkrauti(pav_obj);
		obj_dydis = failas.dydis;
		obj = new char[obj_dydis];
		memcpy(obj, failas.duom, obj_dydis);
		failas.Naikinti();
	}
	
	if(h_tek){
		tgaFailas tga;
		tga.Uzkrauti(pav_tek);
		tek_dydis = tga.x * tga.y * 4;
		h_tek_x = tga.x;
		h_tek_y = tga.y;
		tek = new char[tek_dydis];
		memcpy(tek, tga.dat, tek_dydis);
	}
	else{
		tek_dydis = 0;
	}
	
	//Rasyti
	//Duomenys
	FILE *rez = fopen(pav_issaug, "wb");
	fwrite(swf, 1, swf_dydis, rez);
	fwrite(obj, 1, obj_dydis, rez);
	if(h_tek)
		fwrite(tek, 1, tek_dydis, rez);
	//Headeris
	fwrite(&h_tek_x, 4, 1, rez);
	fwrite(&h_tek_y, 4, 1, rez);
	fwrite(&h_rod, 1, 1, rez);
	fwrite(&h_pele, 1, 1, rez);
	fwrite(&h_double, 1, 1, rez);
	fwrite(&h_smooth, 1, 1, rez);
	fwrite(&h_fonas, 4, 1, rez);
	fwrite(&h_wire, 4, 1, rez);
	fwrite(&h_fps, 4, 1, rez);
	fwrite(&h_kam_z, 4, 1, rez);
	fwrite(&h_kam_zoom, 4, 1, rez);
	fwrite(&h_kam_z, 4, 1, rez);	//Nenaudojamas
	fwrite(&h_pas_x, 4, 1, rez);
	fwrite(&h_pas_y, 4, 1, rez);
	fwrite(&h_pas_z, 4, 1, rez);
	fwrite(&obj_dydis, 4, 1, rez);
	fwrite(&tek_dydis, 4, 1, rez);
	fclose(rez);
	
	//Sukurti HTML
	if(check_html->GetValue()){
		char pav[256], pav2[256];
		int poz, poz2 = 0;
		for(poz = strlen(pav_issaug) - 1; poz >= 0; poz--){
			if(pav_issaug[poz] == '.')
				poz2 = poz;
			if(pav_issaug[poz] == '\\' || pav_issaug[poz] == '/')
				break;
		}
		++poz;
		strncpy(pav, pav_issaug + poz, poz2 - poz);
		pav[poz2 - poz] = '\0';
		strncpy(pav2, pav_issaug, poz2);
		strcat(pav2, ".HTML");
		//Zinute(pav2, "HTML");
		ofstream htm(pav2);
		htm<<"<HTML><BODY>\n";
		htm<<"<EMBED src=\""<<pav<<".swf\" width=\"640\" height=\"480\" quality=\"high\" />";
		htm<<"\n</BODY></HTML>";
		htm.close();
	}
}

/*
 * radio_tekClick
 */
void ProgramaDlg::radio_tekClick(wxCommandEvent& event)
{
	t_tek->SetEditable(true);
	edit_r->SetEditable(false);
	edit_g->SetEditable(false);
	edit_b->SetEditable(false);
}

/*
 * radio_wireClick
 */
void ProgramaDlg::radio_wireClick(wxCommandEvent& event)
{
	t_tek->SetEditable(false);
	edit_r->SetEditable(true);
	edit_g->SetEditable(true);
	edit_b->SetEditable(true);
}

/*
 * sp_pagalbaClick
 */
void ProgramaDlg::sp_pagalbaClick(wxCommandEvent& event)
{
	//if(lang_pagalba == NULL){
		lang_pagalba = new Forma_pag(this);
		//SetTopWindow(dialog);
		lang_pagalba->Show(true);
	//}
	//else{
	//	lang_pagalba->SetFocus();
	//}
}

void ProgramaDlg::Zinute(const wxString &str, const wxString &pav)
{
	wxMessageDialog msg = wxMessageDialog(NULL, str, pav);
	msg.ShowModal();
}
