//---------------------------------------------------------------------------
//
// Name:        Forma_pag.cpp
// Author:      A-E
// Created:     2008-08-28 21:19:55
// Description: Forma_pag class implementation
//
//---------------------------------------------------------------------------

#include "Forma_pag.h"

//Do not add custom headers between
//Header Include Start and Header Include End
//wxDev-C++ designer will remove them
////Header Include Start
////Header Include End

//----------------------------------------------------------------------------
// Forma_pag
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(Forma_pag,wxFrame)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(Forma_pag::OnClose)
	EVT_BUTTON(ID_SP_URL,Forma_pag::sp_urlClick)
END_EVENT_TABLE()
////Event Table End

Forma_pag::Forma_pag(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxFrame(parent, id, title, position, size, style)
{
	CreateGUIControls();
}

Forma_pag::~Forma_pag()
{
}

void Forma_pag::CreateGUIControls()
{
	//Do not add custom code between
	//GUI Items Creation Start and GUI Items Creation End
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	SetTitle(wxT("Informacija"));
	SetIcon(wxNullIcon);
	SetSize(8,8,388,323);
	Center();
	

	sp_url = new wxButton(this, ID_SP_URL, wxT("http://ae.gamedev.lt"), wxPoint(3,265), wxSize(373,21), 0, wxDefaultValidator, wxT("sp_url"));
	sp_url->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	info_text = new wxTextCtrl(this, ID_WXMEMO1, wxT(""), wxPoint(4,6), wxSize(373,255), wxTE_MULTILINE, wxDefaultValidator, wxT("info_text"));
	info_text->SetMaxLength(0);
	info_text->AppendText(wxT("3D swf - tai programa, kurianti 3D swf (flash) failus.\n"));
	info_text->AppendText(wxT("\n"));
	info_text->AppendText(wxT("\n"));
	info_text->AppendText(wxT("Kaip naudotis sia programa?\n"));
	info_text->AppendText(wxT("\n"));
	info_text->AppendText(wxT("  1. 3D failo paruosimas\n"));
	info_text->AppendText(wxT("\n"));
	info_text->AppendText(wxT("    a) 3DsMax\n"));
	info_text->AppendText(wxT("\n"));
	info_text->AppendText(wxT("      1) Sumodeliuok objekta. Objektas turi buti vienas, konvertuotas i\n"));
	info_text->AppendText(wxT("         Editable Mesh.\n"));
	info_text->AppendText(wxT("      2) Eksportuok ASE formatu. Reikia eksportuoti tasku ir teksturu\n"));
	info_text->AppendText(wxT("         koordinates, t. y. prie \"Output Options\" turi buti pazymeta\n"));
	info_text->AppendText(wxT("         \"Mesh Definition\", prie \"Object Types\" - \"Geometric\", prie\n"));
	info_text->AppendText(wxT("         \"Mesh Options\" - \"Mesh Normals\" ir \"Mapping Coordinates\".\n"));
	info_text->AppendText(wxT("\n"));
	info_text->AppendText(wxT("    b) Blender\n"));
	info_text->AppendText(wxT("\n"));
	info_text->AppendText(wxT("      1) Isikelk 3DO eksporteri (3DO.py) i savo skriptu aplanka.\n"));
	info_text->AppendText(wxT("      2) Sumodeliuok objekta. Objektas turi buti vienas, butinai\n"));
	info_text->AppendText(wxT("         sudarytas is trikampiu (ne keturkampiu!).\n"));
	info_text->AppendText(wxT("      3) Eksportuok objekta 3DO formatu.\n"));
	info_text->AppendText(wxT("\n"));
	info_text->AppendText(wxT("  2. Irasymas i SWF\n"));
	info_text->AppendText(wxT("\n"));
	info_text->AppendText(wxT("    1) Pasileisk 3D_swf.exe.\n"));
	info_text->AppendText(wxT("    2) Prie \"Objektas:\" ivesk paruosto 3D failo (ASE ar 3DO) pavadinima.\n"));
	info_text->AppendText(wxT("    3) Prie \"Issaugoti:\" ivesk, kokiu vardu nori issaugoti\n"));
	info_text->AppendText(wxT("       pagaminta swf faila.\n"));
	info_text->AppendText(wxT("    4) Kitus nustatymus pasirink pagal poreikius ir spausk \"GO\".\n"));
	info_text->AppendText(wxT("\n"));
	info_text->AppendText(wxT("\n"));
	info_text->AppendText(wxT("Programos parametru reiksmes:\n"));
	info_text->AppendText(wxT("\n"));
	info_text->AppendText(wxT("  Objektas - 3D objekto (ASE ar 3DO) failas;\n"));
	info_text->AppendText(wxT("  Tekstura - TGA tekstura, palaikomi formatai - 32, 24 ir 8 bpp,\n"));
	info_text->AppendText(wxT("    nepalaikomas suspaudimas;\n"));
	info_text->AppendText(wxT("  Wireframe - karkasinio (wireframe) modelio briaunu spalva;\n"));
	info_text->AppendText(wxT("  Fono spalva - fono spalva;\n"));
	info_text->AppendText(wxT("  2-sided - ar modelio trikampiai matomi is abieju pusiu (veikia tik kai\n"));
	info_text->AppendText(wxT("    naudojama tekstura);\n"));
	info_text->AppendText(wxT("  Smooth - ar naudoti teksturos glotninima;\n"));
	info_text->AppendText(wxT("  Valdymas (rodykles) - sukurti rodykles, kuriomis bus galima valdyti\n"));
	info_text->AppendText(wxT("    objekto pasukima;\n"));
	info_text->AppendText(wxT("  Valdymas pele - objekto pasukima leisti valdyti pele;\n"));
	info_text->AppendText(wxT("  FPS - scenos perpiesimo daznis;\n"));
	info_text->AppendText(wxT("  Kameros Z koordinate - kameros pozicijos Z koordinate;\n"));
	info_text->AppendText(wxT("  Kameros zoom - kameros priartinimas;\n"));
	info_text->AppendText(wxT("  Objekto pasisukimas per kadra - kiek objektas pasisuka per kadra;\n"));
	info_text->AppendText(wxT("  Issaugoti - issaugomo swf failo pavadinimas;\n"));
	info_text->AppendText(wxT("  HTML - ar generuoti html;\n"));
	info_text->AppendText(wxT("  GO - vykdyti;\n"));
	info_text->AppendText(wxT("  ? - programos pagalba.\n"));
	info_text->AppendText(wxT("\n"));
	info_text->AppendText(wxT("\n"));
	info_text->AppendText(wxT("Kiti dalykai, kuriuos reikia zinoti:\n"));
	info_text->AppendText(wxT("\n"));
	info_text->AppendText(wxT("  3D objekto ir teksturos duomenys irasomi i swf faila.\n"));
	info_text->AppendText(wxT("  Teksturos konvertuojamos i 32 bpp formata.\n"));
	info_text->AppendText(wxT("  Wireframe ir fono spalvos nurodomos RGB reiksmemis nuo 0 iki 255.\n"));
	info_text->AppendText(wxT("  Naudojama kairine koordinaciu sistema.\n"));
	info_text->AppendText(wxT("  Smooth naudojimas labai suletina scenos piesima.\n"));
	info_text->AppendText(wxT("  Programa nemokama asmeniniam naudojimui.\n"));
	info_text->AppendText(wxT("\n"));
	info_text->AppendText(wxT("\n"));
	info_text->AppendText(wxT(" 2008 A-E Software "));
	info_text->SetFocus();
	info_text->SetInsertionPointEnd();
	info_text->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));
	////GUI Items Creation End
	SetBackgroundColour(0x00FFFFFF);
	info_text->SetEditable(false);
}

void Forma_pag::OnClose(wxCloseEvent& event)
{
	Destroy();
}

/*
 * sp_urlClick
 */
void Forma_pag::sp_urlClick(wxCommandEvent& event)
{
	wxLaunchDefaultBrowser("http://ae.gamedev.lt", wxBROWSER_NEW_WINDOW);
}
