//---------------------------------------------------------------------------
//
// Name:        ProgramaDlg.h
// Author:      A-E
// Created:     2008-08-20 22:29:12
// Description: ProgramaDlg class declaration
//
//---------------------------------------------------------------------------

#include <stdio.h>
#include <cstring>

#ifndef __PROGRAMADLG_h__
#define __PROGRAMADLG_h__

#ifdef __BORLANDC__
	#pragma hdrstop
#endif

#ifndef WX_PRECOMP
	#include <wx/wx.h>
	#include <wx/dialog.h>
#else
	#include <wx/wxprec.h>
#endif

//Do not add custom headers between 
//Header Include Start and Header Include End.
//wxDev-C++ designer will remove them. Add custom headers after the block.
////Header Include Start
#include <wx/filedlg.h>
#include <wx/checkbox.h>
#include <wx/radiobut.h>
#include <wx/stattext.h>
#include <wx/textctrl.h>
#include <wx/button.h>
////Header Include End

////Dialog Style Start
#undef ProgramaDlg_STYLE
#define ProgramaDlg_STYLE wxCAPTION | wxSYSTEM_MENU | wxDIALOG_NO_PARENT | wxMINIMIZE_BOX | wxCLOSE_BOX | wxNO_3D
////Dialog Style End

#include <wx/stdpaths.h>
#include "Forma_pag.h"
#include "tga.hpp"
#include "f_3do.hpp"

class ProgramaDlg : public wxDialog
{
	private:
		DECLARE_EVENT_TABLE();
		
	public:
		ProgramaDlg(wxWindow *parent, wxWindowID id = 1, const wxString &title = wxT("Programa"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = ProgramaDlg_STYLE);
		virtual ~ProgramaDlg();
		void WxButton1Click(wxCommandEvent& event);
		void WxButton2Click(wxCommandEvent& event);
		void sp_darytiClick(wxCommandEvent& event);
		void sp_issaugClick(wxCommandEvent& event);
		void WxCheckBox1Click(wxCommandEvent& event);
		void ProgramaDlgActivate(wxActivateEvent& event);
		void radio_tekClick(wxCommandEvent& event);
		void radio_wireClick(wxCommandEvent& event);
		void sp_pagalbaClick(wxCommandEvent& event);
	
	private:
		//Do not add custom control declarations between 
		//GUI Control Declaration Start and GUI Control Declaration End.
		//wxDev-C++ will remove them. Add custom code after the block.
		////GUI Control Declaration Start
		wxCheckBox *check_html;
		wxCheckBox *check_smooth;
		wxCheckBox *check_double;
		wxFileDialog *atidaryti2;
		wxFileDialog *atidaryti;
		wxFileDialog *issaugoti;
		wxStaticText *WxStaticText16;
		wxTextCtrl *edit_fb;
		wxStaticText *WxStaticText15;
		wxTextCtrl *edit_fg;
		wxStaticText *WxStaticText14;
		wxTextCtrl *edit_fr;
		wxStaticText *WxStaticText13;
		wxButton *sp_pagalba;
		wxTextCtrl *edit_b;
		wxStaticText *WxStaticText12;
		wxTextCtrl *edit_g;
		wxStaticText *WxStaticText9;
		wxTextCtrl *edit_r;
		wxStaticText *WxStaticText2;
		wxTextCtrl *edit_pas_y;
		wxTextCtrl *edit_poz_y;
		wxStaticText *tekstas;
		wxTextCtrl *edit_kam_zoom;
		wxStaticText *WxStaticText8;
		wxTextCtrl *edit_pas_z;
		wxStaticText *WxStaticText7;
		wxTextCtrl *WxEdit3;
		wxStaticText *WxStaticText6;
		wxStaticText *WxStaticText5;
		wxTextCtrl *edit_pas_x;
		wxStaticText *WxStaticText4;
		wxTextCtrl *edit_kam_z;
		wxStaticText *WxStaticText3;
		wxTextCtrl *edit_fps;
		wxCheckBox *check_pele;
		wxCheckBox *check_rod;
		wxButton *sp_issaug;
		wxTextCtrl *t_issaug;
		wxStaticText *WxStaticText0;
		wxButton *sp_daryti;
		wxRadioButton *radio_wire;
		wxRadioButton *radio_tek;
		wxButton *WxButton2;
		wxTextCtrl *t_tek;
		wxStaticText *WxStaticText1;
		wxTextCtrl *t_obj;
		wxButton *WxButton1;
		////GUI Control Declaration End
		
	private:
		//Note: if you receive any error with these enum IDs, then you need to
		//change your old form code that are based on the #define control IDs.
		//#defines may replace a numeric value for the enum names.
		//Try copy and pasting the below block in your old form header files.
		enum
		{
			////GUI Enum Control ID Start
			ID_WXCHECKBOX1 = 1090,
			ID_WXSTATICTEXT16 = 1088,
			ID_EDIT_FB = 1087,
			ID_WXSTATICTEXT15 = 1086,
			ID_EDIT_FG = 1085,
			ID_WXSTATICTEXT14 = 1084,
			ID_EDIT_FR = 1083,
			ID_WXSTATICTEXT13 = 1082,
			ID_SP_PAGALBA = 1066,
			ID_EDIT_B = 1065,
			ID_WXSTATICTEXT12 = 1064,
			ID_EDIT_G = 1062,
			ID_WXSTATICTEXT9 = 1061,
			ID_EDIT_R = 1059,
			ID_WXSTATICTEXT2 = 1057,
			ID_EDIT_PAS_Y = 1056,
			ID_EDIT_POZ_Y = 1051,
			ID_TEKSTAS = 1049,
			ID_EDIT_POZ_X = 1048,
			ID_WXSTATICTEXT8 = 1037,
			ID_EDIT_PAS_Z = 1036,
			ID_WXSTATICTEXT7 = 1034,
			ID_WXEDIT3 = 1033,
			ID_WXSTATICTEXT6 = 1031,
			ID_WXSTATICTEXT5 = 1030,
			ID_EDIT_PAS_X = 1029,
			ID_WXSTATICTEXT4 = 1027,
			ID_EDIT_KAM_Z = 1026,
			ID_WXSTATICTEXT3 = 1024,
			ID_EDIT_FPS = 1021,
			ID_CHECK_PELE = 1020,
			ID_CHECK_ROD = 1019,
			ID_SP_ISSAUG = 1018,
			ID_T_ISSAUG = 1017,
			ID_WXSTATICTEXT0 = 1016,
			ID_SP_DARYTI = 1012,
			ID_RADIO_WIRE = 1011,
			ID_RADIO_TEK = 1010,
			ID_WXBUTTON2 = 1009,
			ID_T_TEK = 1008,
			ID_WXSTATICTEXT1 = 1007,
			ID_T_OBJ = 1006,
			ID_WXBUTTON1 = 1002,
			////GUI Enum Control ID End
			ID_DUMMY_VALUE_ //don't remove this value unless you have other enum values
		};

		unsigned int
			h_tek_x,
			h_tek_y,
			swf_dydis,
			obj_dydis,
			tek_dydis;
		bool
			h_wire_b,
			h_rod,
			h_pele,
			h_double,
			h_smooth;
		unsigned int
			h_wire,
			h_fonas;
		float
			h_fps,
			h_kam_z,
			h_kam_zoom,
			h_pas_x,
			h_pas_y,
			h_pas_z;
		unsigned int
			h_obj,
			h_tek;
		char
			*pav_swf,
			*pav_obj,
			*pav_tek,
			*pav_issaug,
			*swf,
			*obj,
			*tek;
		unsigned int
			h_r,
			h_g,
			h_b;
		Forma_pag
			*lang_pagalba;
			
	
	private:
		void OnClose(wxCloseEvent& event);
		void CreateGUIControls();
		void Zinute(const wxString& str, const wxString& pav = "Klaida");
};

#endif
