#include "f_3do.hpp"
#include <fstream>
#include <iostream>
using namespace std;


F_3DO::F_3DO():dydis(0), duom(0)
{
}


F_3DO::~F_3DO()
{
}


void F_3DO::Uzkrauti(char *pav)
{
    char eil[256];
    int i = 0, j = 0;
    
    int NUMVERTEX, NUMFACES, NUMTVERTEX, NUMTVFACES, NORMALS;
    float *VERTEXLIST = NULL, *TVERTLIST = NULL, *NORMALLIST = NULL;
	int *FACELIST = NULL, *TFACELIST = NULL;

	NUMFACES = 0;
	NUMFACES = 0;
	NUMFACES = 0;
    
    //Skaityti duomenis ---------------------------------------------------------------------------
    ifstream fd(pav);
    while(fd.good()){
        while(fd.peek() != '*' && fd.good())
            fd.ignore();
        fd.ignore();
        fd.get(eil, 256, ' ');
		
        //----------------------------------------------------------------------
        if(strcmp(eil, "MESH_NUMVERTEX") == 0){//vertexai
            fd>>NUMVERTEX;
            VERTEXLIST = new float[NUMVERTEX * 3];
            continue;
        }
        if(strcmp(eil, "MESH_NUMFACES") == 0){//faces
            fd>>NUMFACES;
            FACELIST = new int[NUMFACES * 3];
            NORMALS = NUMFACES;
            NORMALLIST = new float[NORMALS * 9];
            continue;
        }
        if(strcmp(eil, "MESH_NUMTVERTEX") == 0){//texture vertex
            fd>>NUMTVERTEX;
            TVERTLIST = new float[NUMTVERTEX * 2];
            continue;
        }
        if(strcmp(eil, "MESH_NUMTVFACES") == 0){//texture faces
            fd>>NUMTVFACES;
            TFACELIST = new int[NUMTVFACES * 3];
            continue;
        }
        //----------------------------------------------------------------------
        if(strcmp(eil, "MESH_VERTEX") == 0){
            fd>>i;
            fd>>VERTEXLIST[i * 3]>>VERTEXLIST[i * 3 + 1]>>VERTEXLIST[i * 3 + 2];
            continue;
        }
        if(strcmp(eil, "MESH_FACE") == 0){
            fd>>i;
            fd.ignore(); fd.get(eil, 256, ':'); fd.ignore(); fd>>FACELIST[i * 3];
			fd.ignore(); fd.get(eil, 256, ':'); fd.ignore(); fd>>FACELIST[i * 3 + 1];
			fd.ignore(); fd.get(eil, 256, ':'); fd.ignore(); fd>>FACELIST[i * 3 + 2];
            continue;
        }
        if(strcmp(eil, "MESH_TVERT") == 0){
            fd>>i;
            fd>>TVERTLIST[i * 2]>>TVERTLIST[i * 2 + 1];
            continue;
        }
        if(strcmp(eil, "MESH_TFACE") == 0){
            fd>>i;
            fd>>TFACELIST[i * 3]>>TFACELIST[i * 3 + 1]>>TFACELIST[i * 3 + 2];
            continue;
        }
        if(strcmp(eil, "MESH_FACENORMAL") == 0){
        	fd>>i;
        	j = 0;
		}
		if(strcmp(eil, "MESH_VERTEXNORMAL") == 0){
			fd>>NORMALLIST[i * 9 + j];
            fd>>NORMALLIST[i * 9 + j]>>NORMALLIST[i * 9 + j + 1]>>NORMALLIST[i * 9 + j + 2];
			j += 3;
            continue;
        }
    }   
    fd.close();
    
    
    //Rasyti teksturu koordinaciu masyva
    float *TFACES = new float[NUMFACES * 6];
    for(i = 0; i < NUMFACES; i++){
		for(j = 0; j < 3; j++){
			TFACES[i * 6 + j * 2 + 0] = TVERTLIST[TFACELIST[i * 3 + j] * 2 + 0];
			TFACES[i * 6 + j * 2 + 1] = TVERTLIST[TFACELIST[i * 3 + j] * 2 + 1];
		}
	}
    //Rasyti i viena masyva
    dydis = 24 + 12 * NUMVERTEX + 12 * NUMFACES + 24 * NUMTVFACES;
    duom = new char[dydis];
    duom[0] = 174;
    duom[1] = 6;
    *(unsigned int*)(duom + 4) = NUMVERTEX;
    *(unsigned int*)(duom + 8) = NUMFACES;
    *(unsigned int*)(duom + 12) = 3 * NUMVERTEX;
    *(unsigned int*)(duom + 16) = 3 * NUMFACES;
    *(unsigned int*)(duom + 20) = 6 * NUMTVFACES;
    memcpy((duom + 24), VERTEXLIST, NUMVERTEX * 12);
    memcpy((duom + 24 + NUMVERTEX * 12), FACELIST, NUMFACES * 12);
    memcpy((duom + 24 + NUMVERTEX * 12 + NUMFACES * 12), TFACES, NUMFACES * 24);
    
    cout<<"verts: "<<NUMVERTEX<<", faces: "<<NUMFACES<<endl;
	
	for(i = 0; i < NUMFACES; i++)
		for(j = 0; j < 3; j++){
			cout<<"Coord: "<<VERTEXLIST[FACELIST[i * 3 + j] * 3 + 0]<<" "<<VERTEXLIST[FACELIST[i * 3 + j] * 3 + 1]<<" "<<VERTEXLIST[FACELIST[i * 3 + j] * 3 + 2]<<endl;
			cout<<" Text: "<<TVERTLIST[TFACELIST[i * 3 + j] * 2 + 0]<<" "<<TVERTLIST[TFACELIST[i * 3 + j] * 2 + 1]<<endl;
		}
	
	delete[] VERTEXLIST;
	delete[] TVERTLIST;
	delete[] NORMALLIST;
	delete[] FACELIST;
	delete[] TFACELIST;
	delete[] TFACES;
}


void F_3DO::Naikinti()
{
}
